/*
 * QuotesView.java
 *
 * Created on 10 de agosto de 2004, 17:57
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.QuoteList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.QuoteListViewShopKeeper;

/**
 * Este servlet carga una lista con las cotizaciones realizadas por el minorista
 * y construye una vista que es envíada a la página miscotizaciones.jsp.
 * 
 * @author Mario Linares Vásquez
 *  
 */
public class QuotesView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las solicitudes de los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Este método construye una instancia de la clase
	 * <CODE>QuoteList</CODE> con los atributos <CODE>companyId</CODE> y
	 * <CODE>roleId</CODE> del atributo <CODE>user</CODE> de la sesión,
	 * luego construye la vista con la clase <CODE>QuoteListView</CODE> que se
	 * agrega al <CODE>response</CODE> como atributo con el nombre <CODE>view
	 * </CODE>. El flujo se redirecciona a la página miscotizaciones.jsp
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/miscotizaciones.jsp";
		String message = "";
        HttpSession session = request.getSession( false );

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
	
			}
			else
			{
				int roleId = ((User) session.getAttribute("user"))
				.getRoleId();
				int companyId = ((User) session.getAttribute("user"))
						.getCompanyId();
		
				QuoteList list = new QuoteList(companyId, roleId);
				QuoteListViewShopKeeper view = new QuoteListViewShopKeeper(list);
				request.setAttribute("view", view);
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}